<?php
require_once(_PS_MODULE_DIR_ . 'freshmail/lib/Auth.php');
class AdminFreshmailCheckboxesController extends AdminController {
    
    public $api;
    public $requireFields = array('presta_newsletter', 'presta_partners_newsletter');
    public static $UPDATE_SUCCESS = "Success!";
    
    public function __construct() {
        
        Auth::check();
        
        $this->bootstrap = true;
        $this->lang = true;
        $this->context = Context::getContext();
        parent::__construct();
    }
    
    public function initContent()
    {
        parent::initContent();
        $this->initTabModuleList();
        $this->initToolbar();
        $this->initPageHeaderToolbar();
        $this->addToolBarModulesListButton();
        $this->api = new Api();
        
        $back = $this->context->link->getAdminLink('AdminDashboard');
        $this->toolbar_btn['back'] = array(
            'href' => $back,
            'desc' => $this->l('Back to the dashboard'),
        );
        $hashList = Configuration::get('FRESHMAIL_SIGNUP_HASHLIST');
        
        if (Tools::isSubmit('submitCheckboxes')) {
            $hashList                               = Tools::getValue('hash_list');
            $labelForm                              = Tools::getValue('sign_up_checkboxes_label');
            $checkboxesActive                       = Tools::getValue('sign_up_checkboxes_active');
            $checkboxIncludeFielsa                  = Tools::getValue('sign_up_include_fields');
            
            $acceptEmailsPartnersActive             = Tools::getValue('accept_emails_partners_active');
            $acceptEmailsPartnersActiveLabel        = Tools::getValue('accept_emails_partners_active_label');
            
            $checkboxIncludeFielsaUpdateStatus      = Configuration::updateValue('FRESHMAIL_SIGNUP_INCLUDE_FIELDS', $checkboxIncludeFielsa);
            $hashListUpdateStatus                   = Configuration::updateValue('FRESHMAIL_SIGNUP_HASHLIST', $hashList);
            $labelFormUpdateStatus                  = Configuration::updateValue('FRESHMAIL_SIGNUP_LABEL', $labelForm);
            $checkboxesActiveUpdateStatus           = Configuration::updateValue('FRESHMAIL_SIGNUP_ACTIVE', $checkboxesActive);
            
            $acceptEmailsPartnersActiveStatus       = Configuration::updateValue('FRESHMAIL_ACCEPT_EMAILS_PARTNERS_ACTIVE', $acceptEmailsPartnersActive);
            $acceptEmailsPartnersActiveLabelStatus  = Configuration::updateValue('FRESHMAIL_ACCEPT_EMAILS_PARTNERS_LABEL', $acceptEmailsPartnersActiveLabel);
            
            if($acceptEmailsPartnersActive) {
                if($this->checkRequireFields($hashList) == false) {
                    foreach($this->requireFields as $k => $field) {
                        $data[] = array(
                            'hash'  => $hashList,
                            'name'  => $field,
                            'tag'   => $field,
                            'type'  => '0',
                        );
                    }
                    $this->api->addFields($data);
                    $this->displayWarning($this->l('Required fields "presta_newsletter" and "presta_partners_newsletter" are automatically added to the list'));
                }
            }
            
            if($checkboxIncludeFielsaUpdateStatus && ($hashListUpdateStatus  && $hashList) && $labelFormUpdateStatus 
                    && $checkboxesActiveUpdateStatus && $acceptEmailsPartnersActiveStatus && $acceptEmailsPartnersActiveLabelStatus) {
                Tools::redirectAdmin(self::$currentIndex.'&token='.Tools::getValue('token').'&conf=6');
            }
        }
        
        $lists = $this->api->getAllList();
        
        
        if(!in_array($hashList, $this->api->getAllHashList())) {
            Configuration::updateValue('FRESHMAIL_SIGNUP_HASHLIST', 0);
            $hashList = 0;
        }
        
        if(empty($hashList)) {
            $this->displayWarning($this->l('Your list must includes any fields'));
        } elseif($this->checkRequireFields($hashList) == false) {
            $this->displayWarning($this->l('Your list should include fields tag: "presta_newsletter" and "presta_partners_newsletter" or click save and will be added automatically'));
        }
        
        $helpArray = array(
            'FRESHMAIL_SIGNUP_INCLUDE_FIELDS'           => Configuration::get('FRESHMAIL_SIGNUP_INCLUDE_FIELDS'),
            'FRESHMAIL_SIGNUP_HASHLIST'                 => Configuration::get('FRESHMAIL_SIGNUP_HASHLIST'),
            'FRESHMAIL_SIGNUP_LABEL'                    => Configuration::get('FRESHMAIL_SIGNUP_LABEL'),
            'FRESHMAIL_SIGNUP_ACTIVE'                   => Configuration::get('FRESHMAIL_SIGNUP_ACTIVE'),
            'FRESHMAIL_ACCEPT_EMAILS_PARTNERS_ACTIVE'   => Configuration::get('FRESHMAIL_ACCEPT_EMAILS_PARTNERS_ACTIVE'),
            'FRESHMAIL_ACCEPT_EMAILS_PARTNERS_LABEL'    => Configuration::get('FRESHMAIL_ACCEPT_EMAILS_PARTNERS_LABEL'),
            'url_post'                                  => self::$currentIndex . '&token=' . $this->token,
            'module_templates'                          => _PS_MODULE_DIR_.'freshmail/views/templates/admin/',
            'show_page_header_toolbar'                  => $this->show_page_header_toolbar,
            'page_header_toolbar_title'                 => $this->page_header_toolbar_title,
            'page_header_toolbar_btn'                   => $this->page_header_toolbar_btn,
            'lists'                                     => $lists,
        );
        $this->context->smarty->assign($helpArray);
        
        $this->setTemplate('checkboxes.tpl');
    }
    
    private function checkRequireFields($hashList = null) {
        
        $listFieldsOfSelectedList = $this->api->getAllFieldsByIdHashList($hashList);
        $tags = array();
        foreach($listFieldsOfSelectedList as $k => $v) {
            $tags[] = $v['tag'];
        }
        
        foreach($this->requireFields as $k => $v) {   
            if(!in_array($v, $tags)) {
                return false;
            }
        }
        
        return true;
    }

    public function createTemplate($tpl_name)
    {
        $path = dirname(__FILE__) . DS . '..' . DS . '..' . DS . 'views' . DS . 'templates' . DS . 'admin' . DS;

        return $this->context->smarty->createTemplate($path . $tpl_name, $this->context->smarty);
    }

    public function checkAccess()
    {
        return true;
    }

    public function viewAccess()
    {
        return true;
    }
}