<?php

class AdminFreshmailMessagesController extends AdminController {
    
    public static $UPDATE_SUCCESS = "Success!";
    
    public function __construct() {
        $this->bootstrap = true;
        $this->lang = true;
        $this->context = Context::getContext();
        parent::__construct();
    }
    
    public function initContent()
    {
        parent::initContent();
        $this->initTabModuleList();
        $this->initToolbar();
        $this->initPageHeaderToolbar();
        $this->addToolBarModulesListButton();
        
        $back = $this->context->link->getAdminLink('AdminDashboard');
        $this->toolbar_btn['back'] = array(
            'href' => $back,
            'desc' => $this->l('Back to the dashboard'),
        );
        
        if (Tools::isSubmit('submitCheckboxes')) {
            $submissionSuccessMessage = Tools::getValue('SUBMISSION_SUCCESS_MESSAGE');
            $submissionFailureMessage = Tools::getValue('SUBMISSION_FAILURE_MESSAGE');
            $alreadySubscribedMessage = Tools::getValue('ALREADY_SUBSCRIBED_MESSAGE');
            $invalidEmailAddressMessage = Tools::getValue('INVALID_EMAIL_ADDRESS_MESSAGE');
            $requiredFieldMissingMessage = Tools::getValue('REQUIRED_FIELD_MISSING_MESSAGE');
            $formSubscribeButton = Tools::getValue('FORM_SUBSCRIBE_BUTTON');
            
            $updateSubmissionSuccessMessage = Configuration::updateValue('FRESHMAIL_SUBMISSION_SUCCESS_MESSAGE', $submissionSuccessMessage);
            $updateSubmissionFailureMessage = Configuration::updateValue('FRESHMAIL_SUBMISSION_FAILURE_MESSAGE', $submissionFailureMessage);
            $updateAlreadySubscribedMessage = Configuration::updateValue('FRESHMAIL_ALREADY_SUBSCRIBED_MESSAGE', $alreadySubscribedMessage);
            $updateInvalidEmailAddressMessage = Configuration::updateValue('FRESHMAIL_INVALID_EMAIL_ADDRESS_MESSAGE', $invalidEmailAddressMessage);
            $updateRequiredFieldMissingMessage = Configuration::updateValue('FRESHMAIL_REQUIRED_FIELD_MISSING_MESSAGE', $requiredFieldMissingMessage);
            $updateFormSubscribeButton = Configuration::updateValue('FRESHMAIL_FORM_SUBSCRIBE_BUTTON', $formSubscribeButton);
            
            if($updateSubmissionSuccessMessage && $updateSubmissionFailureMessage && $updateAlreadySubscribedMessage
                    && $updateInvalidEmailAddressMessage && $updateRequiredFieldMissingMessage && $updateFormSubscribeButton) {
                Tools::redirectAdmin(self::$currentIndex.'&token='.Tools::getValue('token').'&conf=6');
            }
        }
        
        $helpArray = array(
            'fields' => array(
                'SUBMISSION_SUCCESS_MESSAGE' => Configuration::get('FRESHMAIL_SUBMISSION_SUCCESS_MESSAGE'),
                'SUBMISSION_FAILURE_MESSAGE' => Configuration::get('FRESHMAIL_SUBMISSION_FAILURE_MESSAGE'),
                'ALREADY_SUBSCRIBED_MESSAGE' => Configuration::get('FRESHMAIL_ALREADY_SUBSCRIBED_MESSAGE'),
                'INVALID_EMAIL_ADDRESS_MESSAGE' => Configuration::get('FRESHMAIL_INVALID_EMAIL_ADDRESS_MESSAGE'),
                'REQUIRED_FIELD_MISSING_MESSAGE' => Configuration::get('FRESHMAIL_REQUIRED_FIELD_MISSING_MESSAGE'),
                'FORM_SUBSCRIBE_BUTTON' => Configuration::get('FRESHMAIL_FORM_SUBSCRIBE_BUTTON')
            ),
            
            'url_post'                  => self::$currentIndex . '&token=' . $this->token,
            'module_templates'          => _PS_MODULE_DIR_.'freshmail/views/templates/admin/',
            'show_page_header_toolbar'  => $this->show_page_header_toolbar,
            'page_header_toolbar_title' => $this->page_header_toolbar_title,
            'page_header_toolbar_btn'   => $this->page_header_toolbar_btn
        );
        
        $this->context->smarty->assign($helpArray);
        $this->setTemplate('messages.tpl');
    }
    
    public function createTemplate($tpl_name)
    {
        $path = dirname(__FILE__) . DS . '..' . DS . '..' . DS . 'views' . DS . 'templates' . DS . 'admin' . DS;

        return $this->context->smarty->createTemplate($path . $tpl_name, $this->context->smarty);
    }

    public function checkAccess()
    {
        return true;
    }

    public function viewAccess()
    {
        return true;
    }
}