<?php

include_once dirname(__FILE__).'/REST-API/class.rest.php';

class Api extends FmRestApi
{
    public function __construct() {
        
        $this->setApiKey(Configuration::get('FRESHMAIL_API_KEY'));
        $this->setApiSecret(Configuration::get('FRESHMAIL_API_SECRECT_KEY'));
    }
    
    public function getAllList() {
        $data = array();
        
        try {
            $responseArray = $this->doRequest('subscribers_list/lists', $data);
            
            $response[0] = array(
                    'key' => 0,
                    'name' => '---'
            );
            
            usort($responseArray['lists'], function($a,$b){
                return strtotime($a['creation_date'])<strtotime($b['creation_date'])?1:-1;
            });
            
            foreach($responseArray['lists'] as $k => $v) {
                $response[$k+1] = array(
                    'key' => $v['subscriberListHash'],
                    'name' => $v['name'] . ' (' . $v['subscribers_number'] . ')'
                );
            }
            
            return $response;
        } catch (Exception $e) {
            syslog(3, 'Code: '.$e->getCode().' Message: '.$e->getMessage());
        }
    }
    
    public function getAllHashList() {
        $res = $this->getAllList();        
        $hashList = array();
        foreach($res as $k => $v) {
            $hashList[] = $v['key'];
        }
        
        if(isset($hashList[0]) && $hashList[0] == 0) {
            unset($hashList[0]);
        }
        
        return $hashList;
    }
    
    public function getAllFieldHashByHashList($id = 0) {
        $res = $this->getAllFieldsByIdHashList($id);        
        $hashList = array();
        foreach($res as $k => $v) {
            if(!empty($v) && isset($v['hash']) && isset($v['tag'])) {
                $hashList[$v['hash']] = $v;
            }
        }
        
        return $hashList;
    }
    
    public function getAllHashListSQL() {      
        $hashList = $this->getAllHashList();
        $result =  implode(',', array_map(function($str) {
            return sprintf("'%s'", $str);
        }, $hashList));
        
        return $result;
    }
    
    public function getAllFieldsByIdHashList($idHash = null) {
        
        if(empty($idHash)) {
            return false;
        }
        
        $data = array('hash' => $idHash);
        
        try {
            $responseArray = $this->doRequest('subscribers_list/getFields', $data);
            
            if(isset($responseArray['fields']) && !empty($responseArray['fields'])) {
                return $responseArray['fields'];
            }
            
            return array();
        } catch (Exception $e) {
            echo 'Code: '.$e->getCode().' Message: '.$e->getMessage()."\n";
        }
    }
     
    
    public function addSubscriber($data = null) {
        if(empty($data) || empty($data['email']) || empty($data['list'])) {
            throw new Exception('Brak wymaganych danych !');
        }
        
        $response = $this->doRequest('subscriber/add', $data);
        return $response;
    }
    
    public function addFields($fields = array()) {
        if(empty($fields)) {
            return false;
        }
        
        foreach($fields as $k => $data) {
            try {
                $response = $this->doRequest('subscribers_list/addField', $data);
            } catch (Exception $e) {
                throw new Exception('Wystąpił błąd podczas dodawania nowego pola!');
            }
        }
        
    }
}