<?php

class Field extends ObjectModel
{
    public $id;
    public $displayname;
    public $hash_list;
    public $hash;
    public $include_field;
    public $require_field;
    public $name;
    public $tag;
    public $id_form;
    public $type;
    

    public static $definition = array(
        'table' => 'fm_list_field',
        'primary' => 'id',
        'fields' => array(
            'name' => array(
                'type' => self::TYPE_STRING,
                'validate' => 'isGenericName',
                'required' => true,
                'class' => 'lg'
            ),
            'tag' => array(
                'type' => self::TYPE_STRING,
                'validate' => 'isGenericName',
                'required' => true,
            ),
            'displayname' => array(
                'type' => self::TYPE_STRING,
                'validate' => 'isGenericName',
            ),
            'hash_list' => array(
                'type' => self::TYPE_STRING,
                'required' => true
            ),
            'hash' => array(
                'type' => self::TYPE_STRING,
                'required' => true
            ),
            'include_field' => array(
                'type' => self::TYPE_INT,
            ),
            'require_field' => array(
                'type' => self::TYPE_INT,
            ),
            'id_form' => array(
                'type' => self::TYPE_INT,
                'required' => true,
            ),
            'type' => array(
                'type' => self::TYPE_STRING,
                'required' => true,
            ),
        ),
    );
    
    public static function getFieldsByIdForm($id = null)
    {
        if(empty($id)) {
            return array();
        }
        
        $id = (int) $id;
        
        $sql = 'SELECT * FROM '._DB_PREFIX_.'fm_list_field WHERE (`id_form` = ' . $id .')';
        $collection = array();
        if ($rows = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql)) {
            foreach($rows as $key => $row) {
                $collection[] = (array)new Field($row['id']);
            }
            
            return $collection;
        } else {
            return array();
        }
    }
    
    public function getFieldsHashByIdForm($id = 0) {
        $sql = 'SELECT * FROM '._DB_PREFIX_.'fm_list_field WHERE (`id_form` = ' . $id .')';
        $collection = array();
        if ($rows = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql)) {
            foreach($rows as $key => $row) {
                $collection[] = $row['hash'];
            }
            
            return $collection;
        } else {
            return array();
        }
        
        return $collection;
    }
    
    public static function getFieldsForUserRegistrationForm($tags = false)
    {
        $formId = Configuration::get('FRESHMAIL_SIGNUP_HASHLIST');
        
        if(!$formId) {
            return false;
        }
        if($tags) {
            $sql = 'SELECT tag FROM '._DB_PREFIX_.'fm_list_field WHERE id_form = "' . (int)$formId . '" ';
        } else {
            $sql = 'SELECT * FROM '._DB_PREFIX_.'fm_list_field WHERE id_form = "' . (int)$formId . '" AND include_field = 1';
        }
        
        if ($rows = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql)) {
            if($tags) {
                $arrayTags = array();
                foreach($rows as $k => $v) {
                    $arrayTags[] = $v['tag'];
                }
                
                return $arrayTags;
            } else {
                return $rows;
            }
        } else {
            return false;
        }
    }
}