<?php
class Form extends ObjectModel
{
    public $id;
    public $hash_list;
    public $name;
    public $count;
    public $position;
    public $fields;
    public $active;
    public $confirm;
    public $subscribers_status;

    public static $definition = array(
        'table' => 'fm_form',
        'primary' => 'id_fm_form',
        'fields' => array(
            'name' => array(
                'type' => self::TYPE_STRING,
                //'validate' => 'isGenericName',
                'required' => true,
                'class' => 'lg'
            ),
            'hash_list' => array(
                'type' => self::TYPE_STRING,
                'required' => true
            ),
            'count' => array(
                'type' => self::TYPE_INT,
                'required' => false
            ),
            'position' => array(
                'type' => self::TYPE_INT,
                'required' => true
            ),
            'active' => array(
                'type' => self::TYPE_INT
            ),
            'confirm' => array(
                'type' => self::TYPE_INT
            ),
            'subscribers_status' => array(
                'type' => self::TYPE_INT
            ),
        ),
        'associations' => array(
            'fields' => array('type' => self::HAS_MANY, 'field' => 'id_fm_form', 'object' => 'Field'),
        )
    );
    
    public function __construct($id = null, $id_lang = null, $id_shop = null)
    {
        parent::__construct($id, $id_lang, $id_shop);
        if ($id) {
            $this->fields = Field::getFieldsByIdForm($id);
        }
  }
    
    
    public static function getFormById($id = null)
    {
        if(empty($id)) {
            return false;
        }
        
        $id = (int) $id;
        
        $sql = 'SELECT * FROM '._DB_PREFIX_.'fm_form WHERE (`id_fm_form` = ' . $id .')';
        if ($row = Db::getInstance(_PS_USE_SQL_SLAVE_)->getRow($sql)) {
          $form = new Form($row['id_fm_form']);
          return $form;
        } else {
          return false;
        }
    }
    
    public static function getAllFormsFull() {
        $sql = 'SELECT a.`id_fm_form`, a.`hash_list`, a.`position`, a.`active`, count('._DB_PREFIX_.'fm_list_field.id) as `count_fields`, `a`.`name` '
                . ' FROM '._DB_PREFIX_.'fm_form a'
                . ' LEFT JOIN '._DB_PREFIX_.'fm_list_field ON a.id_fm_form = '._DB_PREFIX_.'fm_list_field.id_form '
                . ' GROUP BY a.id_fm_form';
        $lists = array();
        if ($rows = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql)) {
            foreach($rows as $k => $v) {
                $lists[] = $v;
            }
        }
        return $lists;
    }
    
    public static function getAllForms()  {
        
        $sql = 'SELECT a.`id_fm_form`, a.`hash_list`, a.`position`, a.`active`, count('._DB_PREFIX_.'fm_list_field.id) as `count_fields`, `a`.`name` '
                . ' FROM '._DB_PREFIX_.'fm_form a'
                . ' LEFT JOIN '._DB_PREFIX_.'fm_list_field ON a.id_fm_form = '._DB_PREFIX_.'fm_list_field.id_form '
                . ' GROUP BY a.id_fm_form';
        
        if ($rows = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql)) {
            
            $lists = array();
            $lists[0] = array(
                    'key' => 0,
                    'name' => '---'
            );
            foreach($rows as $k => $v) {
                $lists[$k+1] = array(
                    'key' => $v['id_fm_form'],
                    'name' => $v['name'] . ' (' . $v['count_fields'] . ')'
                );
            }

            return $lists;
        }
    }
}